%define upstream_name    Glib
%define upstream_version 1.303

%define Werror_cflags %nil

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 9

Summary:    Perl module for the glib-2.x library
License:    LGPLv2+
Group:      Development/GNOME and GTK+
Url:        http://gtk2-perl.sf.net/
# https://sourceforge.net/project/showfiles.php?group_id=64773&package_id=91217
Source0:    http://prdownloads.sourceforge.net/gtk2-perl/%{upstream_name}-%{upstream_version}.tar.gz
# BUG: we do not hanble exceptions out of Gtk2->main loop
# we should just horribly die in that case
Patch0:     Glib-1.280-exception-trapping.patch

BuildRequires: perl(ExtUtils::Depends) >= 0.300.0
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(ExtUtils::PkgConfig) >= 1.0.0
BuildRequires: glib2-devel >= 2.0.0
BuildRequires: perl-devel
Conflicts:	perl-Gtk2 <= 1
# so that live upgrade doesn't fail in rpmdrake or gurpmi due to running
# with a version older than the one it was compiled for
Requires:   glib2 => %(pkg-config --modversion glib-2.0 &>/dev/null && pkg-config --modversion glib-2.0 2>/dev/null || echo 0)

%description
This module provides perl access to Glib and GLib's GObject libraries.
It is mainly used by perl-GTK2 applications.

Glib is a handy library of portability and utility functions. This C library
is designed to solve some portability problems and provide other useful
functionality which most programs require.

GObject provides a generic type system with inheritance and a powerful signal
system.

Together these libraries are used as the foundation for many of the libraries
that make up the Gnome environment, and are used in many unrelated
projects.

%package doc
Summary:    Glib documentation
Group:      Documentation
BuildArch:  noarch

%description doc
This package contains documentation of the Glib module.

%prep
%setup -q -n %{upstream_name}-%{upstream_version}
%apply_patches
find -type d -name CVS | rm -rf 

%build
perl Makefile.PL INSTALLDIRS=vendor
%define _disable_ld_no_undefined 1
%make OPTIMIZE="$RPM_OPT_FLAGS" OTHERLDFLAGS="%{?ldflags}" PERL_ARCHIVE_AFTER="-lpthread"

%check
# disabled due to long time faillures
%make test

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AUTHORS LICENSE META.json META.yml MYMETA.yml NEWS README TODO
%dir %{perl_vendorarch}/%{upstream_name}
%{perl_vendorarch}/%{upstream_name}.pm
%{perl_vendorarch}/%{upstream_name}/*.pm
%{perl_vendorarch}/%{upstream_name}/*/*.pm
%{perl_vendorarch}/%{upstream_name}/Install
%{perl_vendorarch}/auto/*

%files doc
%defattr(-, root, root)
%{_mandir}/*/*
%dir %{perl_vendorarch}/%{upstream_name}
%{perl_vendorarch}/%{upstream_name}/*.pod
%{perl_vendorarch}/%{upstream_name}/*/*.pod


%changelog
* Mon Dec 16 2013 tv <tv> 1.303.0-9.mga4
+ Revision: 557308
- try to reenable testsuite

* Mon Dec 16 2013 tv <tv> 1.303.0-8.mga4
+ Revision: 557190
- fix perl-Gtk2 build

* Sat Dec 14 2013 tv <tv> 1.303.0-7.mga4
+ Revision: 556796
- new release

* Thu Dec 05 2013 tv <tv> 1.302.0-7.mga4
+ Revision: 555413
- enable to bind GSpawnFlags for mcc's drakconsole

* Tue Dec 03 2013 tv <tv> 1.302.0-6.mga4
+ Revision: 554794
- fix exception management (mga#11860)

* Mon Dec 02 2013 tv <tv> 1.302.0-5.mga4
+ Revision: 554668
- export generic_exceptions_handler() for Gtk3ion()
  (thus fixing a regression in callback exception management)
- make patch more upstreamable by not affecting default behavior

* Thu Nov 07 2013 tv <tv> 1.302.0-4.mga4
+ Revision: 549861
- relax calling convention for handle_one_exception()

* Thu Nov 07 2013 tv <tv> 1.302.0-3.mga4
+ Revision: 549852
- export handle_one_exception()
  (current framework was ignoring some exceptions with GtK3)

* Mon Oct 21 2013 umeabot <umeabot> 1.302.0-2.mga4
+ Revision: 538366
- Mageia 4 Mass Rebuild

* Mon Sep 30 2013 tv <tv> 1.302.0-1.mga4
+ Revision: 489464
- new release

* Wed Sep 25 2013 tv <tv> 1.301.0-2.mga4
+ Revision: 485845
- patch 1: avoid memory corruption when registering boxed synonyms repeatedly.
- patch 1: avoid misusing the macro PL_na, thus preventing issues when Glib is
  used in conjunction with certain XS modules, among them XML::Parser and
  String::Approx.

* Sun Jul 07 2013 sander85 <sander85> 1.301.0-1.mga4
+ Revision: 450933
- update to 1.301.0

* Wed May 29 2013 jquelin <jquelin> 1.300.0-3.mga4
+ Revision: 430708
- perl 5.18.0 rebuild

* Wed May 29 2013 tv <tv> 1.300.0-2.mga4
+ Revision: 429919
- rebuild for new perl

* Thu May 23 2013 tv <tv> 1.300.0-1.mga4
+ Revision: 424721
- new release

* Sun Mar 03 2013 tv <tv> 1.290.0-5.mga3
+ Revision: 401293
- export glib_perl_set_execept_errs for Gtk2::NotificationBubble

* Wed Feb 20 2013 tv <tv> 1.290.0-4.mga3
+ Revision: 399562
- fix gtk_main for apps not using exceptions

* Wed Feb 20 2013 tv <tv> 1.290.0-3.mga3
+ Revision: 399480
- reexport another symbol

* Tue Feb 19 2013 tv <tv> 1.290.0-2.mga3
+ Revision: 399458
- make new exception management as robust as previous one
  (should fix some bugs such as mga#8768)
- comment/explain the exception patch

* Mon Feb 11 2013 tv <tv> 1.290.0-1.mga3
+ Revision: 397888
- new release

* Sun Feb 10 2013 tv <tv> 1.280.0-5.mga3
+ Revision: 397758
- fix license

* Sun Jan 13 2013 umeabot <umeabot> 1.280.0-4.mga3
+ Revision: 367757
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 18 2012 tv <tv> 1.280.0-3.mga3
+ Revision: 332245
- call dlclose() when needed

* Mon Dec 17 2012 tv <tv> 1.280.0-2.mga3
+ Revision: 331904
- patch 0: add a generic exception handler
  (works for both gtk+-2 & gtk+-3 with hacking perl-GtkX)

* Sat Nov 03 2012 tv <tv> 1.280.0-1.mga3
+ Revision: 313468
- new release

* Wed Oct 10 2012 jquelin <jquelin> 1.270.0-2.mga3
+ Revision: 304078
- fix rpm group

* Sun Aug 26 2012 tv <tv> 1.270.0-1.mga3
+ Revision: 284297
- new release

* Fri Aug 03 2012 tv <tv> 1.262.0-3.mga3
+ Revision: 278325
- rebuild with compressed debug info

* Thu Aug 02 2012 tv <tv> 1.262.0-2.mga3
+ Revision: 277896
- rebuild with mini debug info

* Wed Aug 01 2012 tv <tv> 1.262.0-1.mga3
+ Revision: 277631
- new release

* Thu Jul 05 2012 jquelin <jquelin> 1.261.0-1.mga3
+ Revision: 268178
- update to 1.261

* Mon Jun 04 2012 tv <tv> 1.260.0-2.mga3
+ Revision: 254060
- require glib version used to compile (mga#6274)

* Wed May 30 2012 tv <tv> 1.260.0-1.mga3
+ Revision: 251797
- META.json is no more
- new release

* Wed May 30 2012 jquelin <jquelin> 1.251.0-3.mga3
+ Revision: 250648
- rebuild for perl 5.16

* Sun Mar 25 2012 tv <tv> 1.251.0-2.mga2
+ Revision: 226446
- bump required version so that live upgrade works after priorty upgrade of
  perl, perl-Glib for rpmdrake or gurpmi (mga#5066)

* Mon Mar 05 2012 jquelin <jquelin> 1.251.0-1.mga2
+ Revision: 218752
- update to 1.251

* Mon Jan 23 2012 tv <tv> 1.250.0-1.mga2
+ Revision: 200394
- new release

* Tue Jan 03 2012 tv <tv> 1.242.0-1.mga2
+ Revision: 190150
- new release

* Mon Nov 21 2011 tv <tv> 1.241.0-1.mga2
+ Revision: 170185
- adjust file list
- new release

* Fri Oct 14 2011 jquelin <jquelin> 1.240.0-1.mga2
+ Revision: 154768
- update to 1.240

* Mon Oct 03 2011 tv <tv> 1.233.0-3.mga2
+ Revision: 151266
- new release
- new release
- drop patch 1 (merged)

  + fwang <fwang>
    - new version 1.232
    - do not link against rpath libperl
    - use system flags

* Sun Jun 12 2011 sander85 <sander85> 1.230.0-9.mga2
+ Revision: 104321
- Rebuild for perl 5.14

* Thu May 26 2011 ennael <ennael> 1.230.0-8.mga1
+ Revision: 100520
- update glib2 version require (#1432)

* Fri Jan 21 2011 jquelin <jquelin> 1.230.0-7.mga1
+ Revision: 30485
- mageia rebuild
- imported package perl-Glib

